sub ParseFilterFile($)
{
	my $FilterFile = shift;

	my %Filter = ();

	local *FilterFile;
	undef $!;
	open( FilterFile, $FilterFile );
	if ( $! and ( $! !~ m/Inappropriate ioctl for device/i ) )
	{
		error( "erreur d'ouverture du filtre $FilterFile : $!" );
		return ();
	}
	while( my $Line = <FilterFile> )
	{
		$Line =~ s/\r|\n//g;
		if ( $Line )
		{
			my ( $Key, $Value ) = split( /=/, $Line, 2 );
			$Filter{$Key} = $Value;
		}
	}
	close( FilterFile );

	return %Filter;
}

sub DeleteFilterFile($)
{
	my $FilterFile = shift;

	unlink 'generated/Filters/'.$FilterFile.'.flt';
}

1;
